#!/usr/bin/python

import gtk
import gtk.glade
import gnome.ui
import gnome
import gobject
import pango

import DNS
from  NamedConf import *
import RRGUI
from View import *

class NewView:
    def answer(s,r,noParms=None):
        s.response(s.dialog, gtk.RESPONSE_OK, r)
        
    def response(s,d,r, answer=None):
        if r == gtk.RESPONSE_OK:
            name = s.nameEntry.get_text()
            if (len(name) == 0) :
                s.bind.gui.modalError(s.dialog,_('View Name Error'),_('You must specify a name for this view.'),fatal=False)
                return False
            if s.bind.views.has_key(name):
                s.bind.gui.modalError(s.dialog,_('View Name Error'),_('View "%s" already exists.') % name,fatal=False)
                return False
            s.inACLWidget.save()
            s.outACLWidget.save()
            if( len(s.inACL.addrs) <= 0):
                s.bind.gui.modalError(s.dialog,_('View From: ACL Error'),_('You must specify a "From:" access control list filter.'),fatal=False)
                return False
            if( len(s.outACL.addrs) <= 0):
                s.bind.gui.modalError(s.dialog,_('View To: ACL Error'),_('You must specify a "To:" access control list filter.'),fatal=False)
                return False                           
            if (not s.bind.isViewed):
                if( answer == None ):
                    if s.nmdc.objs.has_key('include'):
                        ask = s.bind.gui.question(s.dialog,
                                              _("Warning: DNS Configuration Restructuring Required"),
                                              _("Creating a new view will result in restructuring of your DNS configuration files.\nThe contents of files that are 'include'd in named.conf (except keys) will be moved to named.conf.\nDo you want to proceed with restructuring and create the new view?"))
                        ask.question(s.answer)
                        return False                    
                elif(answer == gtk.RESPONSE_CANCEL):
                    return False
                s.nmdc.firstView(name,s.inACL.out(),s.outACL.out())
                s.bind.load()
            else:                
                vk = '"'+name+'"'
                s.nmdc[ [ 'view', vk ] ] = 'view '+vk+' {\n\tmatch-clients ' + s.inACL.out() + '\n\tmatch-destinations ' + s.outACL.out() + '\n};\n'
                s.nmdc.update()
                s.bind.views[name] = { 'key': vk, 'zones': {}, 'keys':{}, 'servers':{} }
                s.bind.views[name]['view']= View(s.nmdc, vk, s.bind.views[name])
                s.bind.zoneTree.load()
                # Copy RFC 1912 mandatory TLDs and root hints to new view:
                for origin in [ '.', 'localhost.', 'localhost.localdomain.', '0.0.127.in-addr.arpa', '0.in-addr.arpa.', '255.in-addr.arpa.', '0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.ip6.arpa.' ]:
                    for v in s.bind.views.keys():
                        if v == name:
                            continue
                        if s.bind.views[v]['zones'].has_key( origin ):
                            s.bind.copyZone(origin, v, name)
                            break
        s.dialog.destroy()                      
        return False
        
    def __init__(s,bind):
        s.bind = bind
        s.gui = s.bind.gui
        s.nmdc = s.bind.nmdc
        s.dialog = gtk.Dialog(title=_("New View"), parent=s.bind.gui.gui,
                              buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
                                       gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL
                                      )
                             )
        s.nFrame = gtk.Frame(_('View Name'))
        s.nameEntry = gtk.Entry()
        s.nFrame.add(s.nameEntry)
        s.inACL = DNS.ACL({'any':None},s.nmdc)
        s.outACL = DNS.ACL({'any':None},s.nmdc)
        s.inACLFrame=gtk.Frame(_('From: Access Control List Filter'))
        s.outACLFrame=gtk.Frame(_('To: Access Control List Filter'))
        s.inACLWidget = RRGUI.DNS_ACL(s,s,s.inACL,'inACL')
        s.outACLWidget = RRGUI.DNS_ACL(s,s,s.outACL,'outACL')
        s.inACLFrame.add(s.inACLWidget.widget())
        s.outACLFrame.add(s.outACLWidget.widget())
        s.dialog.vbox.pack_start(s.nFrame)
        s.dialog.vbox.pack_start(s.inACLFrame)
        s.dialog.vbox.pack_start(s.outACLFrame)
        s.dialog.connect('response',s.response)
        s.dialog.show_all()
        
