import os
import commands
import socket
import time
import datetime
import gtk
import gtk.glade
import gnome.ui
import gnome
import gobject
import pango

import DNS
import RRGUI
from Zone   import *
from EditDialog import *
from NamedConfOptions import O
from RR     import *
from RREdit import *

class NewZone:
    class NullZone:
        origin=''
        zone_origin=''
        type=None
        clas=None
        records=[]
        ttl=None
        def In(s,arg):
            return True    
    zTypes=[[_('Forward'), DNS.FORWARD, DNS.Name],
            [_('IPV4 Reverse'), DNS.IPV4.REVERSE, DNS.IPV4.ReverseAddress],
            [_('IPV6 Reverse'), DNS.IPV6.REVERSE_ARPA, DNS.IPV6.ReverseARPAddress],
            [_('NSAP Reverse'), DNS.NSAP.REVERSE, DNS.NSAP.ReverseAddress]
           ]
    type=DNS.FORWARD

    def rootCacheDownload(s,d, complete=False):        
        gobject.source_remove(s.rcdSID)
        if (complete == False):
            s.bind.load()
            s.rcdLabel.set_text(_('Root Cache Download Complete.'))
            s.rcdSID=gobject.timeout_add(2000, s.rootCacheDownload,d,True)
            d.resize_children()
            d.show_all()
            return False
        d.hide()
        d.destroy()
        return False

    def answer(s,ans,arg=None):
        s.response(s.dialog,gtk.RESPONSE_OK,answer=ans)
        
    def response(s,d,r, answer=None):
        if (r == gtk.RESPONSE_OK):
            debug( 'NEW ZONE RESPONSE OK')
            dns_name_dialog={}
            if (s.zone.type != None) and (s.zone.clas != None) and (
               (s.name != None) and hasattr(s,'originWidget') and
               ((not(hasattr(s.originWidget,'focus_out')))or(s.originWidget.focus_out(s.originWidget.entry,None,False,dns_name_dialog)==False)) and
               (len(s.originWidget.value())>0)):
                if dns_name_dialog.has_key('yes') and (dns_name_dialog['yes']>0) :                    
                    return False
                name = s.originWidget.value()
                debug( 'ZONE EXISTS:',s.nmdcKey,name)
                s.typeWidget.save()
                debug( 'ZONE TYPE:', s.options['type'].value())
                zoneExists = s.bind.zone(name,s.nmdcKey)
                if zoneExists == None:
                    zoneExists = s.bind.zone(name, s.nmdcKey + ['zone'])
                if ( zoneExists != None ) and (zoneExists['zone'].clas == s.zone.clas):
                    s.gui.modalError(s.dialog,_('Zone Origin Error'),_('A zone with origin "%s" of class "%s" already exists. Specify another zone origin.') %(name, s.zone.clas),fatal=False
                                    )
                    return False
                if( name == '.'):
                    if( s.options['type'].value() == 'master'):
                        if(answer==None):
                            ans = s.gui.question(s.dialog, _("DNS Name Question"), _("Do you really want to create a top level root domain ('.') master server?"))
                            ans.question(s.answer)
                            return False
                        elif(answer == gtk.RESPONSE_CANCEL):
                            s.gui.modalError(s.dialog,_("Zone Type Error"),_("You must enter a Zone Origin that is not root ('.')."))
                            s.originWidget.entry.grab_focus()
                            return False
                    elif( s.options['type'].value() == 'hint' ):
                        # New Root Cache ...
                        s.nmdcKey += [ '"." IN' ]
                        s.bind.nmdc [ s.nmdcKey ] = 'zone "." IN {\n\ttype hint;\n\tfile "named.root";\n};\n'
                        try:
                            os.unlink( s.bind.nmdc.directory() + '/named.root' )
                        except:
                            pass
                        s.bind.nmdc.update()
                        s.rcdLabel = gtk.Label(_('Downloading Root Cache...'))
                        d.vbox.pack_start( s.rcdLabel )
                        d.resize_children()
                        d.show_all()
                        s.rcdSID=gobject.timeout_add(2000, s.rootCacheDownload,d,False)                    
                        return False
                s.zone.origin = str(s.name)                
                s.zone.zone_origin=s.zone.origin
                s.originWidget.save()
                debug( 'ZONE ORIGIN:',str(s.name))
                name=s.name.value()
                debug( 'NAME:', name)
                s.title='Zone' + name
                s.typeWidget.save()
                if not hasattr(s,'required_records'):
                    s.dialog.vbox.remove(s.originFrame)
                    s.dialog.vbox.remove(s.typeFrame)
                    zoneType = s.options['type'].value()
                    host=s.bind.server_name()
                    s.zone.origin = str(s.name)
                    s.zone.zone_origin=s.zone.origin
                    s.name.origin =  s.zone.origin
                    s.name.zone_origin = s.zone.origin                    
                    s.zone.records=[]
                    if( zoneType == 'slave' ) or ( zoneType == 'stub' ):
                        s.options['masters'] = DNS.AddressList({})
                        s.mastersFrame = gtk.Frame(s.name.value()+ ' ' +  _('Master Name Server List'))
                        s.mastersWidget = RRGUI.DNS_AddressList(s,s.options,s.options['masters'],'masters')
                        s.mastersFrame.add(s.mastersWidget.widget())
                        s.dialog.vbox.pack_start(s.mastersFrame)
                    elif( zoneType == 'forward' ):
                        s.options['forwarders'] = DNS.AddressList({})
                        s.forwardersFrame = gtk.Frame(s.name.value()+ ' ' +  _('Forwarder Name Server List'))
                        s.forwardersWidget = RRGUI.DNS_AddressList(s,s.options,s.options['forwarders'],'forwarders')
                        s.forwardersFrame.add(s.forwardersWidget.widget())
                        s.dialog.vbox.pack_start(s.forwardersFrame)
                    if zoneType != 'forward':                        
                        if( zoneType != 'slave' ) and ( zoneType != 'stub' ):
                            s.soaFrame=gtk.Frame(s.name.value()+ ' ' + SOA.desc[''])
                            s.soa = SOA( s.zone,s.name,None,None,
                                         [ s.name,'SOA', host, 'root.' + host, 1, '3h', '1h', '1w', '1h'],
                                         [],
                                         2
                                       )
                            debug( 'SOA TTL:',s.soa.ttl)
                            s.soaEdit = RREdit(s.zoneTree, s.soa, s.soaFrame)
                            s.dialog.vbox.pack_start(s.soaFrame)                        
                        fname=s.bind.zone_file(s.zone,str(s.name),True,zoneType)                       
                        s.fname = DNS.Path( fname )                    
                        s.fileWidget = RRGUI.DNS_Path(s,s,s.fname,'file')
                        s.fFrame=gtk.Frame(_('Zone File Path'))
                        s.fFrame.add(s.fileWidget.widget())
                        s.dialog.vbox.pack_start(s.fFrame)
                    debug( 'ZONE ORIGIN:',s.zone.zone_origin)
                    debug( 'NAME ORIGIN:',s.name.zone_origin)
                    s.dialog.show_all()
                    s.required_records=True
                    return False
                elif s.options['type'].value() != 'forward':
                    path_problem={}
                    debug( 'CHECK FILE:',s.warned)
                    s.fileWidget.entry_focus_out(None,None,path_problem)
                    if  path_problem.has_key('yes'):
                        if( s.fileWidget.warned and not s.warned ):
                            s.warned = True                            
                            return False
                        elif not s.fileWidget.warned :
                            return False
                    s.fileWidget.save()
                    if s.options['type'].value() not in [ 'slave', 'stub' ]:
                        s.soaEdit.save()
                        debug( 'SOA TTL AFTER SAVE:', s.soa.name.value(), s.soa.ttl)
                    else:
                        fname = s.fname.value()
                        if (fname[:7] != 'slaves/') and (fname[0] != '/'):
                            if ( answer == None ):
                                ans = s.gui.question(s.dialog, _("Warning: zone transfers will be disabled"),
                                                     _("Bad location for slave/stub zone file: %s.\nZone transfers are disabled by default in directory\n %s.\nShall I put the slave zone file in slaves/?") % ( s.fname, s.bind.nmdc.directory()) )
                                ans.question(s.answer)
                                return False
                            elif ( answer == gtk.RESPONSE_OK ):
                                s.fname.path = 'slaves/'+fname
                zoneType = s.options['type'].value()
                fname=None
                if zoneType == 'forward':
                    s.forwardersWidget.save()
                    if len(s.options['forwarders'].addrs)<= 0:
                        s.gui.modalError(s.dialog,_('Forward Zone Error'),_('You must specify a non-empty list of forwarder name servers for a forward zone.') ,fatal=False)
                        return False
                elif (zoneType == 'slave') or (zoneType == 'stub'):
                    s.mastersWidget.save()
                    if len(s.options['masters'].addrs)<=0:
                        s.gui.modalError(s.dialog,_('Slave Zone Error'),_('You must specify a non-empty list of master name servers for a slave zone.') ,fatal=False)
                        return False
                    fname=s.fname.value()
                else:
                    fname=s.fname.value()
                debug( 'CREATE NEW ZONE:', s.zone.clas, s.zone.type, s.options['type'].value(), s.name.value(), fname, 'ORIGIN:',s.zone.origin, 'zone_origin:', s.zone.zone_origin)
                zoneType = s.options['type'].value()
                if( zoneType in ['forward','slave','stub'] ):
                    s.soa = None
                    s.ns = None
                else:
                    s.ns = NS( s.zone,s.name, None, None, [ s.name.value(), 'NS', s.soa.MNAME.value() ], [], 2)
                s.bind.create_zone( s.nmdcKey, s.zone.clas, s.zone.origin, s.zone.type, s.options['type'].value(), fname, s.soa, s.ns, s.options)
                d.destroy()
                return False
            elif(s.zone.type == None):
                s.gui.modalError(s.dialog,_("Zone Type Error"),_("You must choose a Zone Origin Type and set the Zone Origin."))
                s.typeCB.grab_focus()
            elif(s.zone.clas == None):
                s.gui.modalError(s.dialog,_("Zone Type Error"),_("You must choose the Zone Class."))
                s.classCB.grab_focus()
            elif( (s.originWidget() == None) or (len(s.originWidget.value())<=0) ):
                s.gui.modalError(s.dialog,_("Zone Type Error"),_("You must enter a valid Zone Origin."))
                s.originWidget.entry.grab_focus()
            return False
        d.destroy()
        return False
    
    def choose_class(s,cb):
        s.zone.clas = RR.classes[ s.classCB.get_active() ]
        s.classButton.hide()
        s.classContainer.remove(s.classButton)
        s.classButton.destroy()
        s.classCB.hide()
        s.classContainer.remove(s.classCB)
        s.classCB.destroy()
        s.classContainer.pack_start(gtk.Label(s.zone.clas))
        s.classContainer.show_all()
        
    def choose_type(s,cb,zType = None):
        zInfo=s.zTypes[0]
        if( zType == None):
            zInfo =  s.zTypes[ s.typeCB.get_active() ]
        else:
            for zt in s.zTypes:
                if zt[1] == zType:
                    zInfo = zt
                break
        s.zone.type = zInfo[1]
        s.typeButton.hide()
        s.originContainer.remove(s.typeButton)
        s.typeButton.destroy()
        s.typeCB.hide()
        s.originContainer.remove(s.typeCB)
        s.originLabel.set_text(zInfo[0] + ' ' + _('Zone Origin'))
        s.name=zInfo[2]('',s.zone)
        s.originWidget = RRGUI.widget(RRGUI, s.name)(s,s,s.name,'name')
        s.origin_widget=s.originWidget.widget()
        s.originContainer.pack_start(s.origin_widget)
        s.originContainer.show_all()
        
    def __init__(s,z,nmdcKey=None,clas=None,origin=None,zType=None):
        s.zoneTree = z
        s.bind=z.bind
        s.gui=s.bind.gui
        s.zone=NewZone.NullZone()
        s.dialog = gtk.Dialog(title=_("New Zone"), parent=s.bind.gui.gui,
                              buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
                                       gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL
                                      )
                             )
        s.editDialog = s.dialog
        s.warned=False
        if ( nmdcKey == None ):
            s.nmdcKey = [ ]
            s.zone.nmdcKey=['zone']
        else:
            s.nmdcKey = nmdcKey
            s.zone.nmdcKey=nmdcKey
        debug( 'NEW ZONE nmdcKey:',s.nmdcKey)
        s.originFrame = gtk.Frame(label=_("Origin"))
        s.originHB = gtk.HBox()
        s.classContainer = gtk.VBox()
        s.classContainer.pack_start(gtk.Label(_('Class')))
        s.originContainer=gtk.VBox()
        if clas == None:
            s.classCB = gtk.combo_box_new_text()
            chosen=0
            i=0
            for c in RR.classes:
                if( c == 'IN' ):
                    chosen=i
                s.classCB.append_text(c+"\t"+RR.classes_desc[i])
                i+=1
            s.classCB.set_active(chosen)
            s.classContainer.pack_start(s.classCB)
            s.classButton = gtk.Button(stock=gtk.STOCK_OK)
            s.classButton.connect('clicked',s.choose_class)
            s.classContainer.pack_start(s.classButton)
        else:
            s.zone.clas = clas
            s.classContainer.pack_start(gtk.Label(clas))
        if (zType == None) or not(zType in [ DNS.FORWARD, DNS.IPV4_REVERSE,
                                             DNS.IPV6.REVERSE_ARPA, DNS.IPV6.REVERSE_INT,
                                             DNS.NSAP.REVERSE
                                           ]
                                 ):
            s.typeCB = gtk.combo_box_new_text()
            for t in s.zTypes:
                s.typeCB.append_text(t[0])
            s.typeCB.set_active(0)
            s.originLabel=gtk.Label(_('Origin Type'))
            s.originContainer.pack_start(s.originLabel)
            s.originContainer.pack_start(s.typeCB)
            s.typeButton = gtk.Button(stock=gtk.STOCK_OK)
            s.originContainer.pack_start(s.typeButton)
            s.typeButton.connect('clicked',s.choose_type)
        else:
            s.choose_type(s.typeCB,zType)
        s.originHB.pack_start(s.classContainer)
        s.originHB.pack_start(s.originContainer)
        s.originFrame.add(s.originHB)
        s.dialog.vbox.pack_start(s.originFrame)
        s.typeFrame=gtk.Frame(_('Zone Type'))
        s.options={}
        s.options['type'] = O['type']['type']('master',O['type']['values'])
        s.typeWidget = RRGUI.widget(RRGUI,s.options['type'])(s,s, s.options['type'], 'type')
        s.typeFrame.add(s.typeWidget.widget())
        s.dialog.vbox.pack_start(s.typeFrame)
        s.dialog.connect('response',s.response)        
        s.dialog.show_all()
